<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" 
        xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
        xmlns:xs="http://www.w3.org/2001/XMLSchema">
    <xsl:strip-space elements="*"/>
    <xsl:output method="text" /> 
    
<!-- Copyright Kathleen Dollard 2002 -->
    
<!-- Main template that calls other templates for fragments -->
<xsl:template match="/DataSet">  
    <xsl:call-template name="Header" />
    <xsl:apply-templates select="DataTable" mode="PrivateDeclarations" />
    <xsl:apply-templates select="Relation" mode="PrivateDeclarations" />
    <xsl:call-template name="SetConstructors" />
    <xsl:apply-templates select="DataTable" mode="TableProperties" />
    <xsl:call-template name="Clone" />
    <xsl:call-template name="SerializableStuff" />
    <xsl:call-template name="InitMethods" />
    <xsl:apply-templates select="DataTable" mode="ShouldSerializeMethods" />
    <xsl:call-template name="SchemaChanged" />
    <xsl:apply-templates select="DataTable" mode="RowChangedDelegates" />
    <xsl:apply-templates select="DataTable" mode="DerivedTableRowEvent" />
End Class
</xsl:template>
   
<!-- Fragment Templates -->   
<xsl:template name="Header">
   '------------------------------------------------------------------------------
' &lt;autogenerated&gt;
'     This code was generated by a tool: XSLT Generation based on->
'     the ADO.NET Runtime Version: 1.0.3705.0
'
'     Changes to the generated file may cause incorrect behavior and will be lost if 
'     the code is regenerated.
' &lt;/autogenerated&gt;
'------------------------------------------------------------------------------

Option Strict Off
Option Explicit On

Imports System
Imports System.Data
Imports System.Runtime.Serialization
Imports System.Xml


&lt;Serializable(),  _
 System.ComponentModel.DesignerCategoryAttribute("code"),  _
 System.Diagnostics.DebuggerStepThrough(),  _
 System.ComponentModel.ToolboxItem(true)&gt;  _
Public Class <xsl:value-of select="@name"/>
   Inherits DataSet
</xsl:template>
   
<xsl:template match="DataTable" mode="PrivateDeclarations">
   Private table<xsl:value-of select="@name"/> As <xsl:value-of select="@name"/>DataTable
</xsl:template>
   
<xsl:template match="Relation" mode="PrivateDeclarations">
   Private relation<xsl:value-of select="@name"/> As DataRelation
</xsl:template>

<xsl:template name="SetConstructors">
   Public Sub New()
        MyBase.New
        Me.InitClass
        Dim schemaChangedHandler As System.ComponentModel.CollectionChangeEventHandler = AddressOf Me.SchemaChanged
        AddHandler Me.Tables.CollectionChanged, schemaChangedHandler
        AddHandler Me.Relations.CollectionChanged, schemaChangedHandler
    End Sub
    
    Protected Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
        MyBase.New
        Dim strSchema As String = CType(info.GetValue("XmlSchema", GetType(System.String)),String)
        If (Not (strSchema) Is Nothing) Then
            Dim ds As DataSet = New DataSet
            ds.ReadXmlSchema(New XmlTextReader(New System.IO.StringReader(strSchema)))
            <xsl:apply-templates select="DataTable" mode="Constructor" />
            Me.DataSetName = ds.DataSetName
            Me.Prefix = ds.Prefix
            Me.Namespace = ds.Namespace
            Me.Locale = ds.Locale
            Me.CaseSensitive = ds.CaseSensitive
            Me.EnforceConstraints = ds.EnforceConstraints
            Me.Merge(ds, false, System.Data.MissingSchemaAction.Add)
            Me.InitVars
        Else
            Me.InitClass
        End If
        Me.GetSerializationData(info, context)
        Dim schemaChangedHandler As System.ComponentModel.CollectionChangeEventHandler = AddressOf Me.SchemaChanged
        AddHandler Me.Tables.CollectionChanged, schemaChangedHandler
        AddHandler Me.Relations.CollectionChanged, schemaChangedHandler
    End Sub
</xsl:template>

<xsl:template match="DataTable" mode="Constructor">
            If (Not (ds.Tables("<xsl:value-of select="@name" />")) Is Nothing) Then
                Me.Tables.Add(New <xsl:value-of select="@name" />DataTable(ds.Tables("<xsl:value-of select="@name" />")))
            End If
</xsl:template>

<xsl:template match="DataTable" mode="TableProperties">
   &lt;System.ComponentModel.Browsable(false),  _
     System.ComponentModel.DesignerSerializationVisibilityAttribute(System.ComponentModel.DesignerSerializationVisibility.Content) &gt;  _
    Public ReadOnly Property <xsl:value-of select="@name" /> As <xsl:value-of select="@name" />DataTable
        Get
            Return Me.table<xsl:value-of select="@name" />
        End Get
    End Property
</xsl:template>

<xsl:template name="Clone">
    Public Overrides Function Clone() As DataSet
        Dim cln As <xsl:value-of select="@name"/> = CType(MyBase.Clone,<xsl:value-of select="@name"/>)
        cln.InitVars
        Return cln
    End Function
</xsl:template>

<xsl:template name="SerializableStuff">
   Protected Overrides Function ShouldSerializeTables() As Boolean
        Return false
    End Function
    
    Protected Overrides Function ShouldSerializeRelations() As Boolean
        Return false
    End Function
    
    Protected Overrides Sub ReadXmlSerializable(ByVal reader As XmlReader)
        Me.Reset
        Dim ds As DataSet = New DataSet
        ds.ReadXml(reader)
        <xsl:apply-templates select="DataTable" mode="SerializableStuff" />
        Me.DataSetName = ds.DataSetName
        Me.Prefix = ds.Prefix
        Me.Namespace = ds.Namespace
        Me.Locale = ds.Locale
        Me.CaseSensitive = ds.CaseSensitive
        Me.EnforceConstraints = ds.EnforceConstraints
        Me.Merge(ds, false, System.Data.MissingSchemaAction.Add)
        Me.InitVars
    End Sub
    
    Protected Overrides Function GetSchemaSerializable() As System.Xml.Schema.XmlSchema
        Dim stream As System.IO.MemoryStream = New System.IO.MemoryStream
        Me.WriteXmlSchema(New XmlTextWriter(stream, Nothing))
        stream.Position = 0
        Return System.Xml.Schema.XmlSchema.Read(New XmlTextReader(stream), Nothing)
    End Function
</xsl:template>

<xsl:template match="DataTable" mode="SerializableStuff">
        <xsl:comment> This is just like the Constructor except column position </xsl:comment>
        If (Not (ds.Tables("<xsl:value-of select="@name"/>")) Is Nothing) Then
            Me.Tables.Add(New <xsl:value-of select="@name"/>DataTable(ds.Tables("<xsl:value-of select="@name"/>")))
        End If
</xsl:template>

<xsl:template name="InitMethods" >
    Friend Sub InitVars()
        <xsl:apply-templates select="DataTable" mode="InitVars" />
        <xsl:apply-templates select="Relation" mode="InitVars" />
    End Sub
    
    Private Sub InitClass()
        Me.DataSetName = "Northwind"
        Me.Prefix = ""
        Me.Namespace = "http://tempuri.org/<xsl:value-of select="@name"/>.xsd"
        Me.Locale = New System.Globalization.CultureInfo("en-US")
        Me.CaseSensitive = false
        Me.EnforceConstraints = true
        <xsl:apply-templates select="DataTable" mode="InitClass" />

        Dim fkc As ForeignKeyConstraint
        <xsl:apply-templates select="Relation" mode="InitClass" />
        Me.relationCustomersOrders = New DataRelation("CustomersOrders", New DataColumn() {Me.tableCustomers.CustomerIDColumn}, New DataColumn() {Me.tableOrders.CustomerIDColumn}, false)
        Me.Relations.Add(Me.relationCustomersOrders)
        Me.relationOrdersOrder_Details = New DataRelation("OrdersOrder_Details", New DataColumn() {Me.tableOrders.OrderIDColumn}, New DataColumn() {Me.tableOrder_Details.OrderIDColumn}, false)
        Me.Relations.Add(Me.relationOrdersOrder_Details)
    End Sub
</xsl:template>
 
<xsl:template match="DataTable" mode="InitVars">
        Me.table<xsl:value-of select="@name"/> = CType(Me.Tables("<xsl:value-of select="@name"/>"),<xsl:value-of select="@name"/>DataTable)
        If (Not (Me.table<xsl:value-of select="@name"/>) Is Nothing) Then
            Me.table<xsl:value-of select="@name"/>.InitVars
        End If
</xsl:template>

<xsl:template match="Relation" mode="InitVars">
        Me.relation<xsl:value-of select="@name"/> = Me.Relations("<xsl:value-of select="@name"/>")
</xsl:template>

<xsl:template match="DataTable" mode="InitClass">
        Me.table<xsl:value-of select="@name"/> = New <xsl:value-of select="@name"/>DataTable
        Me.Tables.Add(Me.table<xsl:value-of select="@name"/>)
</xsl:template>

<xsl:template match="Relation" mode="InitClass">
        fkc = New ForeignKeyConstraint( "<xsl:value-of select="@name"/>", New DataColumn() {Me.table<xsl:value-of select="ParentTable" />.<xsl:for-each select="ParentKeys" ><xsl:value-of select="." />Column</xsl:for-each>}, New DataColumn() {Me.table<xsl:value-of select="ChildTable" />.<xsl:for-each select="ChildKeys" ><xsl:value-of select="." />Column</xsl:for-each>})
        Me.table<xsl:value-of select="ChildTable" />.Constraints.Add(fkc)
        fkc.AcceptRejectRule = AcceptRejectRule.None
        fkc.DeleteRule = Rule.Cascade
        fkc.UpdateRule = Rule.Cascade
</xsl:template>

<xsl:template match="DataTable" mode="ShouldSerializeMethods" >
    Private Function ShouldSerialize<xsl:value-of select="@name"/>() As Boolean
        Return false
    End Function
</xsl:template>

<xsl:template name="SchemaChanged">
    Private Sub SchemaChanged(ByVal sender As Object, ByVal e As System.ComponentModel.CollectionChangeEventArgs)
        If (e.Action = System.ComponentModel.CollectionChangeAction.Remove) Then
            Me.InitVars
        End If
    End Sub
</xsl:template>

<xsl:template match="DataTable" mode="RowChangedDelegates">
    Public Delegate Sub <xsl:value-of select="@name"/>RowChangeEventHandler(ByVal sender As Object, ByVal e As <xsl:value-of select="@name"/>RowChangeEvent)
</xsl:template>
 
<xsl:template match="DataTable" mode="DerivedTableRowEvent">
	<xsl:call-template name="DerivedTable"/>
	<xsl:call-template name="DerivedRow"/>
	<xsl:call-template name="DerivedEvent"/>
</xsl:template>

    
</xsl:stylesheet>

  