'Copyright Kathleen Dollard 2002
Option Explicit On 
Option Strict On
Imports System
Imports System.Diagnostics

Public Structure XSLTArgument
   Public Name As String
   Public Value As Object
End Structure

Public Class Transform
   Public Shared Sub Transform( _
         ByVal xslFileName As String, _
         ByVal xmlFileName As String, _
         ByVal outFileName As String, _
         ByVal ParamArray argsForXSL() As XSLTArgument)
      Dim writerOut As IO.StreamWriter
      Dim docXML As Xml.XPath.XPathDocument
      Dim xslTransform As New Xml.Xsl.XslTransform()
      Dim xslArgs As New Xml.Xsl.XsltArgumentList()
      Dim arg As XSLTArgument
      Try
         For Each arg In argsForXSL
            xslArgs.AddParam(arg.Name, "", arg.Value)
         Next
         xslTransform.Load(xslFileName)
         docXML = New Xml.XPath.XPathDocument(xmlFileName)
         writerOut = New IO.StreamWriter(outFileName, False, System.Text.Encoding.UTF8)
         xslTransform.Transform(docXML, xslArgs, writerOut)
         writerOut.Flush()
         writerOut.Close()
      Catch ex As System.Exception
         ' TODO: Handle any exceptions here
         Debug.WriteLine(ex)
         Throw ex
      End Try
   End Sub

   Public Shared Sub TransformXML( _
      ByVal xslFileName As String, _
      ByVal xmlFileName As String, _
      ByVal outFileName As String, _
      ByVal ParamArray argsForXSL() As XSLTArgument)
      Dim writerOut As Xml.XmlTextWriter
      Dim docXML As Xml.XPath.XPathDocument
      Dim xslTransform As New Xml.Xsl.XslTransform()
      Dim xslArgs As New Xml.Xsl.XsltArgumentList()
      Dim arg As XSLTArgument
      Try
         For Each arg In argsForXSL
            xslArgs.AddParam(arg.Name, "", arg.Value)
         Next
         xslTransform.Load(xslFileName)
         docXML = New Xml.XPath.XPathDocument(xmlFileName)
         writerOut = New Xml.XmlTextWriter(outFileName, System.Text.Encoding.UTF8)
         xslTransform.Transform(docXML, xslArgs, writerOut)
         writerOut.Flush()
         writerOut.Close()
      Catch ex As System.Exception
         ' TODO: Handle any exceptions here
         Debug.WriteLine(ex)
         Throw ex
      End Try
   End Sub

End Class
