package trainingant;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Vector;

import org.apache.tools.ant.BuildEvent;
import org.apache.tools.ant.BuildListener;

/**
 * Implements the BuildListener callback interface
 */
public class BuildResultPrinter implements BuildListener {
    private Vector buildMessages = new Vector();

    public BuildResultPrinter() {
    }

    public void buildStarted(BuildEvent e) {
    }

    public void buildFinished(BuildEvent event) {
        Throwable e = event.getException();
        String status = (e != null) ? "failed" : "succeeded";
        String message = "Your Ant build process " + status + ".";
        try {
            PrintStream ps = new PrintStream(new FileOutputStream("build.results"));

            //Writes all logged messages to a file named build.results
            ps.println(message);
            if (buildMessages.size() > 0) {
                ps.println();
                ps.println("The following messages were logged by Ant:");
                ps.println("------------------------------------------");
                ps.println();
                for (int i = 0; i < buildMessages.size(); i++)
                    ps.println((String) buildMessages.get(i));
            }
            ps.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     *  Collects messages as they occur and caches them
     */
    public void messageLogged(BuildEvent event) {
        buildMessages.add(event.getMessage());
    }

    public void targetStarted(BuildEvent event) {
    }

    public void targetFinished(BuildEvent event) {
    }

    public void taskStarted(BuildEvent event) {
    }

    public void taskFinished(BuildEvent event) {
    }
}