package fr.imag.adele.ant.remoreant.impl;

import java.rmi.Naming;
import java.rmi.RMISecurityManager;
import java.rmi.server.UnicastRemoteObject;

import fr.imag.adele.ant.remoreant.RemoteAntService;

public class RemoteAntServer {

	static private final boolean trace = true;

	public static void main(String args[]) {

		// Create and install a security manager 
		if (System.getSecurityManager() == null) {
			System.setSecurityManager(new RMISecurityManager());
		}
		try {
			// Note that the RemoteAntServiceImpl does not extend UnicastRemoteObject.
			RemoteAntService obj = new RemoteAntServiceImpl();
			UnicastRemoteObject.exportObject(obj, Integer.parseInt(args[2]));
			// Bind this object instance to the name "RemoteAntServer" 
			Naming.rebind(args[0], obj);
			if (trace)
				System.out.println("RemoteAntService bound in registry");
		} catch (Exception e) {
			System.out.println("RemoteAntServer err: " + e.getMessage());
			e.printStackTrace();
		}
	}
}
