package fr.imag.adele.ant.remoreant.impl;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintStream;
import java.io.Writer;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.Iterator;
import java.util.Map;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.BuildLogger;
import org.apache.tools.ant.DefaultLogger;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.ProjectHelper;

import fr.imag.adele.ant.remoreant.RemoteAntService;

public class RemoteAntServiceImpl
	extends UnicastRemoteObject
	implements RemoteAntService {
		
	/**
	 * @throws RemoteException
	 */
	protected RemoteAntServiceImpl() throws RemoteException {
		super();
	}

	File tmpDir=new File("tmp");
	int i=1;	
		
	public byte[] execute(
		String buildDocument,
		String target,
		Map properties)
		throws RemoteException, BuildException {

			String buildFileName = "build"+(i++)+".xml";
			File buildFile=new File(tmpDir,buildFileName);
			try {
				buildFile.createNewFile();
				Writer writer=new FileWriter(buildFile);
				writer.write(buildDocument);
				writer.close();
			} catch (IOException e) {
				throw new BuildException(e);
			}
			
			Project project = new Project();
		
			project.init();
		
			ByteArrayOutputStream baos=new ByteArrayOutputStream();
			PrintStream ps= new PrintStream(baos);
			BuildLogger logger = new DefaultLogger();
			logger.setErrorPrintStream(ps);
			logger.setOutputPrintStream(ps);
			project.addBuildListener(logger);
		
			// set user-define properties
			Iterator e = properties.keySet().iterator();
			while (e.hasNext())
			{
				String arg = (String)e.next();
				String value = (String)properties.get(arg);
				project.setUserProperty(arg, value);
			}
		
			//project.setUserProperty( "ant.file" , buildFile.getAbsolutePath() );
			// first use the ProjectHelper to create the project object
			// from the given build file.
			try
			{
				Class.forName("javax.xml.parsers.SAXParserFactory");
				ProjectHelper.configureProject(project, buildFile);
			}
			catch (Throwable t)
			{
				t.printStackTrace();
				throw new BuildException(t);
			}
		
			//System.out.println("targets are: " + project.getTargets());
			project.executeTarget(target);
			return baos.toByteArray();
	}
}
