<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:template match="/">
		<project name="Send all mails" default="all" basedir=".">
			<target name="all">
				<xsl:apply-templates select="rowset"/>
			</target>
		</project>
	</xsl:template>

	<xsl:template match="rowset">
		<xsl:apply-templates select="row"/>
	</xsl:template>

    <xsl:template match="row">
		<copy file="template.txt" tofile="{@id}.{LASTNAME}.BODY.txt"/>
		<replace file="{@id}.{LASTNAME}.BODY.txt">
			<xsl:apply-templates/>
			<replacefilter token="__#__" value="{@id}"/>
		</replace>
		
		<mail
			from="youraddress@yourorganization.org"
			replyto="yourreplyaddress@yourorganization.org"
			tolist="{EMAIL}"
			subject="Hello {FIRSTNAME} {LASTNAME}"
			messagefile="{@id}.{LASTNAME}.BODY.txt"
			mailhost="yourmailhost"
		/>

		<tstamp>
			<format property="send.time" pattern="MM/dd/yyyy hh:mm:ss aa"/>
		</tstamp>

  <echo file="{@id}.{LASTNAME}.SENT.txt">email to <xsl:value-of select="EMAIL"/> was sent at ${send.time}</echo>
  <echo>email to <xsl:value-of select="EMAIL"/> was sent at ${send.time}</echo>
    	

    </xsl:template>

    <xsl:template match="*">

		 <replacefilter 
			token="__{name()}__" 
			value="{text()}"/>
  </xsl:template>

</xsl:stylesheet>
